#ifndef __MCTD_STARTUP_PARSER_H__
#define __MCTD_STARTUP_PARSER_H__

#include <stdbool.h>

#define MCTD_STARTUP_MAX_PARAMS 32

/* 3GPP TS23.003 defines APN max length is 100 plus double quotation x 2. */
#define MCTD_STARTUP_MAX_PARAM_LEN 102

typedef struct {
    char *type;
    char *value;
} MCTD_TYPE_AND_VALUE_T;

typedef struct {
    int size;
    MCTD_TYPE_AND_VALUE_T tav[MCTD_STARTUP_MAX_PARAMS];
} MCTD_TYPE_AND_VALUE_ARRAY_T;

bool mctd_startup_parse(const char *path, MCTD_TYPE_AND_VALUE_ARRAY_T *p);
void mctd_startup_free(MCTD_TYPE_AND_VALUE_ARRAY_T *p);
char *mctd_startup_get_value(MCTD_TYPE_AND_VALUE_ARRAY_T *p, const char *type);

#endif /* __MCTD_STARTUP_PARSER_H__ */
