#include <stdbool.h>
#include <stdio.h> 
#include <stdlib.h>
#include <string.h>

#include "mctd-log.h"
#include "mctd-wvdial-conf.h"

bool mctd_create_wvdial_conf(const char *apn, const char *username,
                                                        const char *password)
{
    FILE *fp;

    if (!apn) {
        log_warn("apn is null.");
        return false;
    }

    remove("/etc/wvdial.conf");

    fp = fopen("/etc/wvdial.conf", "w");
    if (!fp) {
        perror("fopen /etc/wvdial");
        return false;
    }

    fprintf(fp, "[Dialer Defaults]\n");
    fprintf(fp, "Init1 = ATZ\n");
    fprintf(fp, "Init2 = AT+CFUN=1\n");
    fprintf(fp, "Init3 = AT+COPS?\n");
    fprintf(fp, "Modem Type = Analog Modem\n");
    fprintf(fp, "Dial Command = ATD\n");
    fprintf(fp, "Baud = 460800\n");
    fprintf(fp, "Modem = /dev/ttymxc1\n");
    fprintf(fp, "New PPPD = yes\n");
    fprintf(fp, "Dial Attemps = 0\n");
    fprintf(fp, "ISDN = 0\n");
    fprintf(fp, "APN = %s\n", apn);
    fprintf(fp, "Phone = *99***1#\n");

    if (password && (strlen(password) > 2)) /* ignore "" */
        fprintf(fp, "Password = %s\n", password);
    else
        fprintf(fp, "Password = ''\n");

    if (username && (strlen(username) > 2)) /* ignore "" */
        fprintf(fp, "Username = %s\n", username);
    else
        fprintf(fp, "Username = ''\n");

    fprintf(fp, "Carrier Check = yes\n");
    fprintf(fp, "Auto DNS = 1\n");
    fprintf(fp, "Check Def Route = 1\n");
    fprintf(fp, "Stupid Mode = yes\n");
    fprintf(fp, "Check DNS = 1");

    fclose(fp);
    return true;
}
